' rwRAMAR509.vbs
' swp, ionware
' 10-Nov-2012  initial version

'******************************************************
' Configuration - MAKE CONFIGURATION CHANGES HERE
'******************************************************
' YOU MUST CONFIGURE THESE


'Location of the Route file to be rewritten as RAMAR file
'Ensure you have read/write priviledges to the file.
Const CStrRoute = "TlrtDown.txt"

'Location of the RAMAR Route  file to be created from the route file
'Ensure you have read/write priviledges to the file.
Const CStrRAMARRoute = "Route.dat"

'Location of the RAMAR Reading file to be rewritten as a reading file
'Ensure you have read/write priviledges to the file.
Const CStrRAMARReading = "READING.dat"

'Location of the reading file to be created from the RAMAR reading file
'Ensure you have read/write priviledges to the file.
Const CStrReading = "Reading.txt"


'******************************************************
' Script - DO NOT EDIT BELOW THIS LINE
'******************************************************


dim strRAMARRouteFile
dim strRouteFile
dim strReadingFile
dim strRAMARReadingFile

dim objFSO
dim objFileIn
dim objFileOut

dim sTxt
dim rTxt
dim iRecCount
dim strAction


Const OPEN_FILE_FOR_READING = 1  
Const OPEN_FILE_FOR_WRITING = 2
Const OPEN_FILE_FOR_APPENDING = 8    
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002


Sub AssignGlobals
	strRAMARRouteFile = CStrRAMARRoute
	strRouteFile = CStrRoute
	strReadingFile = CStrReading 
	strRAMARReadingFile = CStrRAMARReading
End Sub

Sub Housekeeping 
	Set objFSO = CreateObject("Scripting.FileSystemObject")
End Sub

Sub VerifyEnvironment(strAction)
	if strAction = "1" then strFile = strRouteFile
	if strAction = "2" then strFile = strRAMARReadingFile
	
	If  Not objFSO.FileExists(strFile) Then
		WScript.Echo "The file named " & strFile & _
			" does not exist.  Aborting."
		wscript.quit
  	End If
End Sub   

Sub OpenFileForReading (strAction)
   if strAction = "1" then strFile = strRouteFile
   if strAction = "2" then strFile = strRAMARReadingFile
   Set objFileIn = objFSO.OpenTextFile(strFile, OPEN_FILE_FOR_READING, True)
End Sub

Sub OpenFileForWriting (strAction)
   if strAction = "1" then strFile = strRAMARRouteFile
   if strAction = "2" then strFile = strReadingFile
   Set objFileOut = objFSO.OpenTextFile(strFile, OPEN_FILE_FOR_WRITING, True)
End Sub

Sub CloseInputFile
   objFileIn.Close
End Sub

Sub CloseOutputFile
   objFileOut.Close
End Sub


Function ZeroFill (ByVal String, ByVal length )
    ZeroFill = Trim(String)
    Do While Len(ZeroFill) < length
        ZeroFill = "0" & ZeroFill
    Loop
End Function


Sub GetActionFromUser

	strAction = InputBox("1. Convert Route file (TRLT to RAMAR) " & vbcrlf & _
		"2. Convert Reading file (RAMAR to TRLT" & vbcrlf & _
		"0. Quit", "Select Action", "0")

End Sub


Sub ConvertRoute

'TLRTDOWN.TXT - Download File			Location C:\Windows\Temp
					
'FIELD	TYPE		SIZE		DESCRIPTION
					
'Serial No	CHAR	1	10	Populated	Meter Serial Number
'Seq_No		CHAR	11	10	Populated	Sequence Number
'Acct_No	CHAR	21	8	Populated	Book/Account Number
'Name		CHAR	29	16	Populated	Customer Name
'Address	CHAR	45	16	Populated	Customer Address
'Prev_Read	CHAR	61	10	Populated	Previous Reading
'Nbr_Digits	CHAR	71	10	Populated	Max # of digits 
'Prev_Cons	CHAR	81	10	Previous Consumption
'Crnt_Read	CHAR	91	10	Current Reading
'Crnt_Cons	CHAR	101	10	Current Consumption
'Cons_Force	CHAR	111	1	Out of Range - Forced
'Date		CHAR	112	15	Date Read MM/DD/YYYY
'Time 		CHAR	127	8	Time Read HH:MM:SS
'Message	CHAR	135	50	Message
'Service	CHAR	185	3	Populated	Service Read

	dim strRouteName
	dim strCustomerName
	dim strAddress
	dim strAccount
	dim strMeterID
	dim strMeterIndex
	dim strMeterDials
	dim strMeterDecimals
	dim strMeterFlags
	dim strMeterTime
	dim strMeterReading
	dim strUtilityCode
	dim strTransponderID
	dim strTamper
	dim strTransponderFlag
	dim strMeterInterface
	
	dim sTxt
	dim rTxt
	
	OpenFileForReading(1)
	OpenFileForWriting(1)


	iRecCount = 0
	
	Do While Not objFileIn.AtEndOfStream
		sTxt = objFileIn.ReadLine
		
		strRouteName = mid(sTxt,1,2) & space(30)
		strCustomerName = mid(sTxt,29, 16) & space(16)
		strAddress = mid(sTxt, 45, 16) & mid(sTxt, 11, 10) & mid(sTxt, 61, 10) & _
			mid(sTxt, 71, 10) & mid(sTxt, 185, 3) & space(32)
		strAccount = mid(sTxt, 21, 8) & space(24)
		strMeterID = mid(sTxt, 1, 10) & space(22)
		strMeterIndex = "1"
		strMeterDials = mid(sTxt, 71,1)
		strMeterDecimals = "0"
		strMeterFlags = space(4)
		strMeterTime = space(14)
		strMeterReading = space(10)
		strUtilityCode = "049"
		strTransponderID = mid(sTxt, 1, 10)
		strTamper = space(3)
		strTransponderFlag = space(2)
		strMeterInterface = "X"
		
		
		rTxt = strRouteName & strCustomerName & strAddress & strAccount & _
			strMeterID & strMeterIndex & strMeterDials & strMeterDecimals & strMeterFlags & strMeterTime & _
			strMeterReading & strUtilityCode & strTransponderID & _
			strTamper & strTransponderFlag & strMeterInterface
			
		'wscript.echo iRecCount & " " & sTxt				
		objFileOut.WriteLine rTxt	
		iRecCount = iRecCount + 1
		
	Loop	
	CloseOutputFile()
	CloseInputFile()
End Sub 

Sub ConvertReading


'TLRTUP.TXT - Upload File			Location C:\Windows\Temp	
						
'FIELD	TYPE		SIZE		DESCRIPTION	
						
'Serial No	CHAR	1	10	Required	Meter Serial Number	
'Seq_No		CHAR	11	10	Required	Sequence Number	
'Acct_No	CHAR	21	8	Required	Book/Account Number	
'Name		CHAR	29	16	Required	Customer Name	
'Address	CHAR	45	16	Required	Customer Address	
'Prev_Read	CHAR	61	10	Required	Previous Reading	
'Nbr_Digits	CHAR	71	10	Required	Max # of digits 	
'Prev_Cons	CHAR	81	10	Optional	Previous Consumption	
'Crnt_Read	CHAR	91	10	Required	Current Reading	
'Crnt_Cons	CHAR	101	10	Required	Current Consumption	Please Populate this field we do not calculate tis field
'Cons_Force	CHAR	111	1	Optional	Out of Range - Forced	
'Date		CHAR	112	15	Optional	Date Read MM/DD/YYYY	
'Time 		CHAR	127	8	Optional	Time Read HH:MM:SS	
'Message	CHAR	135	50	Optional	Message	
'Service	CHAR	185	3	Required	Service Read	

	dim strSerialNo
	dim strSequenceNo
	dim strAccountNo
	dim strName
	dim strAddress
	dim strPreviousRead
	dim strNbrDigits
	dim strPrevCons
	dim strCmtRead
	dim strCmtCons
	dim strConsForce
	dim strDate
	dim strTime
	dim strMessage
	dim strService
	
	
	dim sTxt
	dim rTxt
	
	OpenFileForReading(2)
	OpenFileForWriting(2)

	iRecCount = 0
	
	Do While Not objFileIn.AtEndOfStream
		sTxt = objFileIn.ReadLine
	
		
		strSerialNo= mid(sTxt,243,8) + space(2)
	 	strSequenceNo= mid(sTxt, 65 + 16, 10)
		strAccountNo= mid(sTxt,145,8) 
	 	strName = mid(sTxt,33,16)
	 	strAddress= mid(sTxt,65,16)

'                             address                 seq no             prev read
'		strAddress = mid(sTxt, 45, 16) & mid(sTxt, 11, 10) & mid(sTxt, 61, 10) & _
'                         nbr digits            service
'			mid(sTxt, 71, 10) & mid(sTxt, 185, 3) & space(31)

	 	strPreviousRead= mid(sTxt, 65 + 16+ 10, 10)
	 	strNbrDigits= mid(sTxt, 210, 1) &space(9)
		strPrevCons=   space(10)
	 	strCrntRead= mid(sTxt, 230, 10)
	 	strCrntCons= space(10)
	 	strConsForce=  space(1)
	 	strDate = space(15)
	 	strTime = space(8)
	 	strD= mid(sTxt, 216, 8)
	 	strT= mid(sTxt, 224, 6)
		if strD > space(8) then
			strDate =  mid(strD, 3, 2) + "/" + mid(strD, 5,2) + "/" + mid(strD,1,4) & space(5)
			strTime =  mid(strT, 1, 2) + ":" + mid(strT, 3, 2) + ":" + mid(strT,5,2)
		end if
		
		
	 	strMessage= space(50)
	 	strService= mid(sTxt, 65 + 16 + 10 + 10 + 10, 3)
	 	
		
		rTxt = strSerialNo & _
	 	strSequenceNo & _
		strAccountNo & _
	 	strName & _
	 	strAddress & _
	 	strPreviousRead & _
	 	strNbrDigits & _
		strPrevCons & _
	 	strCrntRead & _
	 	strCrntCons & _
	 	strConsForce & _
	 	strDate & _
	 	strTime & _
	 	strMessage & _
	 	strService

			
		'wscript.echo iRecCount & " " & sTxt				
		objFileOut.WriteLine rTxt	
		iRecCount = iRecCount + 1
		
	Loop	
	CloseOutputFile()
	CloseInputFile()
End Sub 


Call AssignGlobals()

Call Housekeeping()

Call GetActionFromUser()

Call VerifyEnvironment(strAction)

if strAction = "1" then
	Call ConvertRoute
	if iRecCount = 0 then
		wscript.echo "No Records were changed."
	else
		wscript.Echo "File rewritten." & vbcrlf & "RecordCount = " & iRecCount & " record(s)."
	end if
end if

if strAction = "2" then
	Call ConvertReading
	if iRecCount = 0 then
		wscript.echo "No Records were changed."
	else
		wscript.Echo "File rewritten." & vbcrlf & "RecordCount = " & iRecCount & " record(s)."
	end if
end if

if strAction = "0" then
	wscript.echo "Script Aborted."
	wscript.quit
end if

